--- old/usr/src/uts/common/io/mem.c	Sat Mar 11 21:24:11 2017
+++ new/usr/src/uts/common/io/mem.c	Sat Mar 11 21:24:11 2017
@@ -25,6 +25,7 @@
 
 /*
  * Copyright (c) 2015, Joyent, Inc.  All rights reserved.
+ * Copyright 2017 James S Blachly, MD <james.blachly@gmail.com>
  */
 
 /*
@@ -160,6 +161,7 @@
 		{ "allkmem",	M_ALLKMEM,	0,	"all",	"all",	0600 },
 		{ "null",	M_NULL,	PRIVONLY_DEV,	NULL,	NULL,	0666 },
 		{ "zero",	M_ZERO, PRIVONLY_DEV,	NULL,	NULL,	0666 },
+		{ "full",	M_FULL, PRIVONLY_DEV,	NULL,	NULL,	0666 },
 	};
 	kstat_t *ksp;
 
@@ -221,6 +223,7 @@
 	switch (getminor(*devp)) {
 	case M_NULL:
 	case M_ZERO:
+	case M_FULL:
 	case M_MEM:
 	case M_KMEM:
 	case M_ALLKMEM:
@@ -247,6 +250,7 @@
 	switch (getminor(dev)) {
 	case M_NULL:
 	case M_ZERO:
+	case M_FULL:
 	case M_MEM:
 	case M_KMEM:
 	case M_ALLKMEM:
@@ -438,6 +442,14 @@
 
 			break;
 
+		case M_FULL:
+			if (rw == UIO_WRITE) {
+				error = ENOSPC;
+				break;
+			}
+			/* else it's a read, fall through to zero case */
+			/*FALLTHROUGH*/
+
 		case M_ZERO:
 			if (rw == UIO_READ) {
 				label_t ljb;
@@ -827,6 +839,7 @@
 		/* no longer supported with KPR */
 		return (-1);
 
+	case M_FULL:
 	case M_ZERO:
 		/*
 		 * We shouldn't be mmap'ing to /dev/zero here as
